/*
 *	Copyright (C) 2009 Jonathan Naylor, G4KLX
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; version 2 of the License.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 */

#if !defined(__GMSKMODEM_H)
#define	__GMSKMODEM_H

#include "Modem.h"

class CGMSKModem : public IModem {
public:
	CGMSKModem(unsigned int sampleRate, unsigned int symbolRate, float bt);
	virtual ~CGMSKModem();

	virtual MODEM_STATE  decode(float val);
	virtual unsigned int code(bool bit, float* buffer, unsigned int length);

	virtual void         debug(bool set);
	virtual void         reset();

private:
	unsigned int   m_sampleRate;
	unsigned int   m_symbolRate;
	unsigned int   m_symbolLen;
	float*         m_filter;
	float*         m_history;		 // History of the past samples val[n] * val[n-1]
	unsigned       m_historyIdx;
	unsigned short m_phase;
	unsigned short m_phaseInc;
	float          m_val;
	bool           m_bit;
	bool           m_debug;

	void gaussian(float gain, float bt, unsigned int taps);
};

#endif
