/*
 *	Copyright (C) 2009 Jonathan Naylor, G4KLX
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; version 2 of the License.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 */

#include "PatternMatcher.h"


#if !defined(__LIMITEDPATTERNMATCHER_H)
#define	__LIMITEDPATTERNMATCHER_H

enum LPM_STATUS {
	LPM_FOUND,
	LPM_SEARCHING,
	LPM_FAILED
};

class CLimitedPatternMatcher {
public:
	CLimitedPatternMatcher(unsigned int length, const bool* pattern, unsigned int count = 1U, unsigned int limit = 0U);
	virtual ~CLimitedPatternMatcher();

	virtual LPM_STATUS add(bool bit);
	virtual void       debug(bool set);

	virtual void       resetData();
	virtual void       resetCount();
	virtual void       resetAll();

private:
	CPatternMatcher m_matcher;
	unsigned int    m_limit;
	unsigned int    m_count;
};

#endif
