/*
 *	Copyright (C) 2009 Jonathan Naylor, G4KLX
 *
 *	This program is free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; version 2 of the License.
 *
 *	This program is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *	GNU General Public License for more details.
 */

#if !defined(__DSTARTRANSMITTER_H)
#define	__DSTARTRANSMITTER_H

#include "DStarRadioHeaderProcessor.h"
#include "DStarScrambler.h"
#include "SoundWriter.h"
#include "GMSKModem.h"

#define	_CRT_SECURE_NO_WARNINGS
#include <cstdio>

class CDStarTransmitter {
public:
	CDStarTransmitter(ISoundWriter* writer, FILE* fpInfo, FILE* fpAMBE);
	virtual ~CDStarTransmitter();

	virtual bool run();

	virtual void debug(bool set);

private:
	CDStarRadioHeaderProcessor m_header;
	CDStarScrambler            m_scrambler;
	CGMSKModem                 m_modem;
	ISoundWriter*              m_writer;
	FILE*                      m_fpInfo;
	FILE*                      m_fpAMBE;
	float*                     m_buffer;
	unsigned int               m_frameNo;
	unsigned int               m_bitLen;
	bool                       m_debug;

	bool writeBitSync();
	bool writeFrameSync();
	bool writeRadioHeader();
	bool writeAudio();
	bool writeEndPattern();
	bool writeBits(const bool* data, unsigned int length);
	bool parseInfoFile();
};

#endif
